> For the complete documentation index, see [llms.txt](https://docs.mezzanine.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mezzanine.xyz/smart-contracts/source-code/core/module.md).

# Module

[Git Source](https://github.com/EntreDevelopers-Lab-Inc/Mezz-Companies/blob/f7a3e84e3dd5bb33c4bd7f77283983f9e8ba20b2/src/core/modules/Module.sol)

**Inherits:** Initializable, ERC165Upgradeable, TeamControlled, IModule

**Author:** Daniel Yamagata & Naveen Ailawadi

A base contract for modules, which are 'children' of departments and treasuries with bespoke logic and spending capabilities

\*Modules should be deployed as proxies. If ERC1967 proxies, their storage layout should use EIP7201 storage slots Reference:

* [EIP7201](https://eips.ethereum.org/EIPS/eip-7201)
* [ERC1967 Proxies](https://github.com/OpenZeppelin/openzeppelin-contracts/blob/b5a7f977d8a57b6854545522e36d91a0c11723cd/contracts/proxy/ERC1967/ERC1967Proxy.sol*)

## Functions

### constructor

```solidity
constructor();
```

### init

Initializes the state of the module. This initialization is bespoke to each module

```solidity
function init(address initTeam, bytes memory params) external virtual;
```

**Parameters**

| Name       | Type      | Description                                                                 |
| ---------- | --------- | --------------------------------------------------------------------------- |
| `initTeam` | `address` | The team that controls the module                                           |
| `params`   | `bytes`   | The abi-encoded params to be decoded and passed to the module's initializer |

### \_\_Module\_init

```solidity
function __Module_init(address initTeam) internal virtual onlyInitializing;
```

### supportsInterface

*ERC165 support*

```solidity
function supportsInterface(bytes4 interfaceId)
    public
    view
    virtual
    override(ERC165Upgradeable, IERC165)
    returns (bool);
```

### getParent

Returns the parent of 'this'. If 'this' is a department or module, returns the team that directly controls 'this'. If 'this' is the Treasury, returns the sentinel parent, which is address(0x1)

```solidity
function getParent() public view virtual returns (address);
```

**Returns**

| Name     | Type      | Description                                                                              |
| -------- | --------- | ---------------------------------------------------------------------------------------- |
| `<none>` | `address` | The parent, which is either the treasury, a department, a module, or the sentinel parent |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.mezzanine.xyz/smart-contracts/source-code/core/module.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
